// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_LEVENBERG_MARQUARDT_SOLVER_LEVENBERG_MARQUARDT_SOLVER_INITIALIZER_H
#define INITIALIZER_EXOTICA_LEVENBERG_MARQUARDT_SOLVER_LEVENBERG_MARQUARDT_SOLVER_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaLevenbergMarquardtSolverInitializers();
}

namespace exotica
{

class LevenbergMarquardtSolverInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() {return "exotica/LevenbergMarquardtSolver" ;}

    LevenbergMarquardtSolverInitializer() : InitializerBase(),
        Debug( false) ,
        MaxIterations( 100) ,
        Convergence( 0.0) ,
        Damping( 0) ,
        Alpha( Eigen::VectorXd::Ones(1)) ,
        ScaleProblem( "none") 
    {
    }

    LevenbergMarquardtSolverInitializer( std::string _Name, bool _Debug =  false, int _MaxIterations =  100, double _Convergence =  0.0, double _Damping =  0, Eigen::VectorXd _Alpha =  Eigen::VectorXd::Ones(1), std::string _ScaleProblem =  "none") : InitializerBase(),
        Name(_Name) ,
        Debug(_Debug) ,
        MaxIterations(_MaxIterations) ,
        Convergence(_Convergence) ,
        Damping(_Damping) ,
        Alpha(_Alpha) ,
        ScaleProblem(_ScaleProblem) 
    {
    }

    LevenbergMarquardtSolverInitializer(const Initializer& other) : LevenbergMarquardtSolverInitializer()
    {
        if (other.HasProperty("Name")) {const Property& prop=other.properties_.at("Name"); if(prop.IsSet()) Name = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("Debug")) {const Property& prop=other.properties_.at("Debug"); if(prop.IsSet()) Debug = prop.IsStringType()?ParseBool(boost::any_cast<std::string>(prop.Get())):boost::any_cast<bool>(prop.Get());}
        if (other.HasProperty("MaxIterations")) {const Property& prop=other.properties_.at("MaxIterations"); if(prop.IsSet()) MaxIterations = prop.IsStringType()?ParseInt(boost::any_cast<std::string>(prop.Get())):boost::any_cast<int>(prop.Get());}
        if (other.HasProperty("Convergence")) {const Property& prop=other.properties_.at("Convergence"); if(prop.IsSet()) Convergence = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());}
        if (other.HasProperty("Damping")) {const Property& prop=other.properties_.at("Damping"); if(prop.IsSet()) Damping = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());}
        if (other.HasProperty("Alpha")) {const Property& prop=other.properties_.at("Alpha"); if(prop.IsSet()) Alpha = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
        if (other.HasProperty("ScaleProblem")) {const Property& prop=other.properties_.at("ScaleProblem"); if(prop.IsSet()) ScaleProblem = boost::any_cast<std::string>(prop.Get());}
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)LevenbergMarquardtSolverInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaLevenbergMarquardtSolverInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Name") || !other.properties_.at("Name").IsSet()) ThrowPretty("Initializer LevenbergMarquardtSolverInitializer requires property Name to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Name", Property("Name", true, boost::any(Name)));
        ret.properties_.emplace("Debug", Property("Debug", false, boost::any(Debug)));
        ret.properties_.emplace("MaxIterations", Property("MaxIterations", false, boost::any(MaxIterations)));
        ret.properties_.emplace("Convergence", Property("Convergence", false, boost::any(Convergence)));
        ret.properties_.emplace("Damping", Property("Damping", false, boost::any(Damping)));
        ret.properties_.emplace("Alpha", Property("Alpha", false, boost::any(Alpha)));
        ret.properties_.emplace("ScaleProblem", Property("ScaleProblem", false, boost::any(ScaleProblem)));
        return ret;
    }

    std::string Name;
    bool Debug;
    int MaxIterations;
    double Convergence;
    double Damping;
    Eigen::VectorXd Alpha;
    std::string ScaleProblem;
};

}

#include<exotica_levenberg_marquardt_solver/exotica_levenberg_marquardt_solver_initializers_numerator.h>


#endif